<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004-2005 Alessandro De Zorzi and Mirko Grava
 *  
 * Phamm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Phamm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* The main Phamm config file
*
* You need to edit the plugin config files you wish to use
* in each plugin dir
* example: plugins/mail/config.inc.php
*
* @package Phamm
* @subpackage configuration
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/


// LDAP Server Settings
define (LDAP_HOST_NAME,'127.0.0.1');		// The server

define (LDAP_PROTOCOL_VERSION,'3');			// The protocol version

define (LDAP_PORT,'389');					// The server port

define (SUFFIX,'dc=example,dc=tld');		// The container

define (BINDDN,'cn=manager,dc=example,dc=tld');	// The admin bind dn
												// could be rootdn											
// TODO change !!!
$LDAP_BASE		= 'o=hosting,dc=example,dc=tld';	// The container

// Phamm access control Settings
define (NOLOGIN,0);				// 1 if you want skip login

define (SECRET,'secret');		// only needed if NOLOGIN=1

define (FORCE_SSL,0);			// 1 if you want force SSL

// Layout Settings
define (VERSION,'0.3.5');		// The Phamm version

define (HIDE_VERSION,0);		// 1 if you want hide the version

define (REFRESH_TIME,2);		// Seconds after refresh page

define (FUNNY_COLOR,0);			// Funny host color... :-))))

define (LANG_MENU,'select');	// A way to choose languages
								// [select, links, none]
define (DEFAULT_VIEW,'all');	// [all, none]
								// none suggest domains and/or accounts > 1000
$style			= 'phamm';  	// Style name

$language		= 'en_EN';		// Default language

$title			= 'Phamm';		// The page title

$td_width		= '200';		//

$td_width_box	= '100';		//

$supported_languages = array();

$supported_languages["en_GB"] = "English";
$supported_languages["it_IT"] = "Italiano";
// $supported_languages["ll_CC"] = "Your language here";
$supported_languages["fr_FR"] = "Francais";
$supported_languages["de_DE"] = "Deutsch";
$supported_languages["pt_BR"] = "Brasileiro";
$supported_languages["hu_HU"] = "Magyar";
$supported_languages["id_ID"] = "Indonesian";
$supported_languages["ru_RU"] = "Russian";

// PLUGINS SETTING
define (DEFAULT_PLUGIN,'mail'); // The default plugin

// This array contains the active plugins
$plugins = array();
$plugins[] = "mail";
$plugins[] = "pdns";
// $plugins[] = "vadmin";
// $plugins[] = "ftp";
// $plugins[] = "radius";
// $plugins[] = "userInfo";
// $plugins[] = "ripeDB";
// $plugins[] = "whoami";

// This array contains the TLDs (filter option)
$tld = array();
$tld[] = ".com";
$tld[] = ".org";
$tld[] = ".net";
// $tld[] = ".biz";
// $tld[] = ".info";
// $tld[] = ".eu";
// $tld[] = ".it";
// $tld[] = ".ie";
// $tld[] = ".fr";
// $tld[] = ".de";

// Advanced Settings (leave unchanged if unsure!)
define (DEBUG,0); 						// Debug level [0,1]

define (ERROR_LEVEL,1); 				// PHP Error Level [0,1,2,10]

define (ADVANCED_VIEW,0);				// Only for advanced users

define (PHAMM_LOG,0); 					// Log level 0->don't log [0,1,2]

define (LOG_FILE,'/tmp/phamm.log'); 	// Log file

define (PASSWORD_MIN_LENGHT,3);			// Min password length

define (PASSWORD_RND_LENGHT,6);			// Random password length

$chars = array ('p','h','a','m','m');	// Chars for random password

define (ENC_TYPE,'CRYPT');				// Standard LDAP encryption type
										// [CRYPT,MD5,CLEAR]

//define (CUSTOM_SESSION_PATH,'/tmp');	// Unused
define (DEFAULT_DOMAIN,'example.tld');	// Unused


/*
Predefined Constants
set with ldap_set_option($connect,COSTANT,ARG);

LDAP_DEREF_NEVER
LDAP_DEREF_SEARCHING
LDAP_DEREF_FINDING
LDAP_DEREF_ALWAYS
LDAP_OPT_DEREF
LDAP_OPT_SIZELIMIT
LDAP_OPT_TIMELIMIT
LDAP_OPT_PROTOCOL_VERSION
LDAP_OPT_ERROR_NUMBER
LDAP_OPT_REFERRALS
LDAP_OPT_RESTART
LDAP_OPT_HOST_NAME
LDAP_OPT_ERROR_STRING
LDAP_OPT_MATCHED_DN
LDAP_OPT_SERVER_CONTROLS
LDAP_OPT_CLIENT_CONTROLS
LDAP_OPT_DEBUG_LEVEL
GSLC_SSL_NO_AUTH
GSLC_SSL_ONEWAY_AUTH
GSLC_SSL_TWOWAY_AUTH
*/

?>
